package com.casic.dcms.fragment.verify;

import android.os.Handler;
import android.os.Message;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProvider;

import com.casic.dcms.R;
import com.casic.dcms.databinding.FragmentVerifyCaseBinding;
import com.casic.dcms.model.VerifiedCaseModel;
import com.casic.dcms.utils.LocaleConstant;
import com.casic.dcms.view.verify.VerifiedDetailActivity;
import com.casic.dcms.vm.CaseViewModel;
import com.pengxh.androidx.lite.adapter.NormalRecyclerAdapter;
import com.pengxh.androidx.lite.adapter.ViewHolder;
import com.pengxh.androidx.lite.base.AndroidxBaseFragment;
import com.pengxh.androidx.lite.hub.ContextHub;
import com.pengxh.androidx.lite.hub.StringHub;
import com.pengxh.androidx.lite.utils.WeakReferenceHandler;
import com.scwang.smartrefresh.layout.api.RefreshLayout;
import com.scwang.smartrefresh.layout.listener.OnLoadMoreListener;
import com.scwang.smartrefresh.layout.listener.OnRefreshListener;

import java.util.ArrayList;
import java.util.List;

public class CaseVerifiedFragment extends AndroidxBaseFragment<FragmentVerifyCaseBinding> {

    private static final String TAG = "CaseVerifiedFragment";
    private CaseViewModel caseViewModel;
    private NormalRecyclerAdapter<VerifiedCaseModel.DataModel.RowsModel> adapter;
    private WeakReferenceHandler weakReferenceHandler;
    private List<VerifiedCaseModel.DataModel.RowsModel> dataBeans = new ArrayList<>();
    private int pageIndex = 1;
    private boolean isRefresh, isLoadMore = false;

    @Override
    protected void setupTopBarLayout() {

    }

    @Override
    protected void observeRequestState() {

    }

    @Override
    protected void initData() {
        weakReferenceHandler = new WeakReferenceHandler(callback);
        caseViewModel = new ViewModelProvider(this).get(CaseViewModel.class);
        caseViewModel.caseVerifiedModel.observe(this, new Observer<VerifiedCaseModel>() {
            @Override
            public void onChanged(VerifiedCaseModel resultBean) {
                if (resultBean.getCode() == 200) {
                    List<VerifiedCaseModel.DataModel.RowsModel> dataRows = resultBean.getData().getRows();
                    if (isRefresh) {
                        adapter.setRefreshData(dataRows);
                        viewBinding.refreshLayout.finishRefresh();
                        isRefresh = false;
                    } else if (isLoadMore) {
                        if (dataRows.size() == 0) {
                            StringHub.show(requireContext(), "到底了，别拉了");
                        }
                        adapter.setLoadMoreData(dataRows);
                        viewBinding.refreshLayout.finishLoadMore();
                        isLoadMore = false;
                    } else {
                        dataBeans = dataRows;
                        weakReferenceHandler.sendEmptyMessage(202104254);
                    }
                }
            }
        });
    }

    @Override
    public void onResume() {
        super.onResume();
        pageIndex = 1;
        obtainVerifyCaseList();
    }

    public void obtainVerifyCaseList() {
        caseViewModel.obtainVerifyCaseList(LocaleConstant.PAGE_LIMIT, pageIndex, true);
    }

    @Override
    protected void initEvent() {
        viewBinding.refreshLayout.setOnRefreshListener(new OnRefreshListener() {
            @Override
            public void onRefresh(@NonNull final RefreshLayout refreshLayout) {
                isRefresh = true;
                //刷新之后页码重置
                pageIndex = 1;
                obtainVerifyCaseList();
            }
        });
        viewBinding.refreshLayout.setOnLoadMoreListener(new OnLoadMoreListener() {
            @Override
            public void onLoadMore(@NonNull final RefreshLayout refreshLayout) {
                isLoadMore = true;
                pageIndex++;
                obtainVerifyCaseList();
            }
        });
    }

    private final Handler.Callback callback = new Handler.Callback() {
        @Override
        public boolean handleMessage(@NonNull Message msg) {
            if (msg.what == 202104254) {
                if (dataBeans.size() == 0) {
                    viewBinding.emptyView.show(false, "您还没有已办案卷", null, "刷新", new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            pageIndex = 1;
                            obtainVerifyCaseList();
                        }
                    });
                } else {
                    viewBinding.emptyView.hide();
                    adapter = new NormalRecyclerAdapter<VerifiedCaseModel.DataModel.RowsModel>(R.layout.item_case_rv_l, dataBeans) {
                        @Override
                        public void convertView(ViewHolder viewHolder, int position, VerifiedCaseModel.DataModel.RowsModel item) {
                            viewHolder.setText(R.id.caseTitleView, StringHub.filterSpaceOrEnter(item.getDescription()))
                                    .setText(R.id.casePlaceView, "发生地点：" + StringHub.filterSpaceOrEnter(item.getFieldintro()))
                                    .setText(R.id.caseTimeView, "上报时间：" + item.getReportTime());
                        }
                    };
                    viewBinding.caseRecyclerView.setAdapter(adapter);
                    adapter.setOnItemClickedListener(new NormalRecyclerAdapter.OnItemClickedListener<VerifiedCaseModel.DataModel.RowsModel>() {
                        @Override
                        public void onItemClicked(int position, VerifiedCaseModel.DataModel.RowsModel rowsModel) {
                            ContextHub.navigatePageTo(requireContext(), VerifiedDetailActivity.class, rowsModel.getId());
                        }
                    });
                }
            }
            return true;
        }
    };
}
